<?php
$plugindir = dirname(__FILE__);

class WsseAuthHeader extends SoapHeader {

    private $wss_ns = 'http://docs.oasis-open.org/wss/2004/01/oasis-200401-wss-wssecurity-secext-1.0.xsd';

    function __construct($user, $pass, $ns = null) {
        if ($ns)
            $this->wss_ns = $ns;

        $auth = new stdClass();
        $auth->Username = new SoapVar($user, XSD_STRING, NULL, $this->wss_ns, NULL, $this->wss_ns);
        $auth->Password = new SoapVar($pass, XSD_STRING, NULL, $this->wss_ns, NULL, $this->wss_ns);

        $username_token = new stdClass();
        $username_token->UsernameToken = new SoapVar($auth, SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'UsernameToken', $this->wss_ns);

        $security_sv = new SoapVar(
            new SoapVar($username_token, SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'UsernameToken', $this->wss_ns), SOAP_ENC_OBJECT, NULL, $this->wss_ns, 'Security', $this->wss_ns);
        parent::__construct($this->wss_ns, 'Security', $security_sv, true);
    }
}

include_once $plugindir.'/libs/Creditreform.php';

Moto\Hook::on ('render.admin.head.top', function ($event, $value) {

    $value .= '<script src="' . Moto\System::getRelativeUrl('@plugins/moto-store-plugin/extensions/credit_reform_checker/js/credit.js') . '" type="text/javascript"></script>';
    return $value;
});

Moto\Hook::on ('application.plugins', function ($event, $value) {
    $value[] = 'store.storeExtension_creditreform';
    return $value;
});

Moto\Hook::on('MOTOSTORE_HOOK_PROCESS_CUSTOMER_DETAILS',function($event, $customer_data){

      return  MotoStore\Extentions\Creditreform\Creditreform::check($customer_data);

});
