angular.module('store.storeExtension_creditreform',
    ['store']
    )
    .config(['$stateProvider', 'motoUI.MenuServiceProvider', 'motoUI.LinkToServiceProvider', 'coreLibraryWidgetProvider',
        function ($stateProvider, MenuServiceProvider, LinkToServiceProvider, WidgetFactory) {

            MenuServiceProvider
                .getMenu('store_menu')
                .addItem({
                    label: 'Creditreform',
                    state: 'app.store.storeExtension_creditreform',
                    priority: 99,
                    icon: 'icon-store-settings',
                    itemId: 'store-menu-extension-creditreform'
                });
            $stateProvider.state('app.store.storeExtension_creditreform', {
                url: 'creditreform',
                title: 'Creditreform',
                templateUrl:  "@plugins/moto-store-plugin/extensions/credit_reform_checker/template/main.tpl.html",
                controller: 'store.storeExtension_creditreform.controller.CreditreformController'
            });
        }
    ]);

angular.module('store.storeExtension_creditreform').controller ('store.storeExtension_creditreform.controller.CreditreformController', [
    '$scope',
    '$state',
    'store.settings.services.SettingsService',
    function ($scope, $state, SettingsService) {

        var ModuleName = 'storesettings_extentions';

        var defaultOption = {

        };
        $scope.absoluteUrl =  app.config.getAbsoluteUrl('@website');


        SettingsService.getOptions ({modulename: ModuleName})
            .success(
                function (data) {
                    if (!angular.isArray(data))
                    {
                        Object.keys (data).map(function (current) {
                            defaultOption[current] = data[current];
                        });
                    }
                    $scope.options = defaultOption;
                    $scope.options.enable_creditreform = !!($scope.options.enable_creditreform);

                }
            );


        $scope.save = function () {
            SettingsService
                .saveOptions (
                    {
                        modulename: ModuleName,
                        options: $scope.options
                    }
                )
                .success(
                    function (data) {
                        $scope.systemMessenger.success('STORE.SAVED');
                        $scope.options = data;

                    })
                .error (function(error) {
                    $scope.systemMessenger.error('STORE.ERROR.SAVE_CHANGES');
                });
        };
    }
]);
