<?php

namespace MotoStore\Extentions\Frontpad;

use Moto;
use MotoStore;
use MotoStore\Customer\Entity\Customer;
use MotoStore\Order\Entity\Order;
use MotoStore\Settings\Entity\Option;
use MotoStore\Content\Content\DI\SMStatic;
use MotoStore\Settings\Repository\OptionRepository;


class Frontpad
{
    const API_URL = 'https://app.frontpad.ru/api/index.php?';

    public static function newOrder(Order $order = null){
        $optRepository = clone SMStatic::getInstance()
            ->get ('MotoStore\EntityManager')
            ->getRepository ('MotoStore\Settings\Entity\Option');
        $secret =  $optRepository->getOption (Option::OPTION_STORE_SETTINGS_EXTENTIONS, 'frontpad_secret');
        if (!$secret || empty($secret))
            return false;
        $data ='';
        $product = array();
        $product_kol= array();

        foreach ($order->getProducts () as $k=>$products)
        {
            $product [$k] = $products->getSku ();
            $product_kol [$k] = $products->getQuantity ();
        }
        $param['secret'] = $secret;
        $param['street']  = $order->getAddress1();
        $param['home']	= $order->getAddress2();
        $param['apart']	= "";
        $param['phone'] = $order->getContactPhone();
        $param['descr']	= $order->getComment();
        $param['name']	= $order->getFullName();

        foreach ($param as $key => $value) {
            $data .= "&".$key."=".$value;
        }

        foreach ($product as $key => $value){
            $data .= "&product[".$key."]=".$value."";
            $data .= "&product_kol[".$key."]=".$product_kol[$key]."";
        }
        $url = self::API_URL . 'new_order';
        return MotoStore\Extentions\Frontpad\Request::executeRequest($url, $data, "POST");
    }
}