angular.module('store.storeExtension_ordersexport',
    ['store']
    )
    .config(['$stateProvider', 'motoUI.MenuServiceProvider', 'motoUI.LinkToServiceProvider', 'coreLibraryWidgetProvider',
        function ($stateProvider, MenuServiceProvider, LinkToServiceProvider, WidgetFactory) {

            MenuServiceProvider
                .getMenu('store_menu')
                .addItem({
                    label: 'Orders Export',
                    state: 'app.store.storeExtension_ordersexport',
                    priority: 99,
                    icon: 'icon-store-settings',
                    itemId: 'store-menu-extension-ordersexport'
                });
            $stateProvider.state('app.store.storeExtension_ordersexport', {
                url: 'orders-export',
                title: 'Orders Export',
                templateUrl:  "@plugins/moto-store-plugin/extensions/orders_export/template/main.tpl.html",
                controller: 'store.storeExtension_ordersexport.controller.OrdersexportController'
            });
        }
    ]);

angular.module('store.storeExtension_ordersexport').service('store.storeExtension_ordersexport.services.OrderExportService',['jsonrpc', function (jsonrpc) {
    var service = jsonrpc.newService('store_order_service');
    this.export = service.createMethod('export');

}]);
angular.module('store.storeExtension_ordersexport').controller ('store.storeExtension_ordersexport.controller.OrdersexportController', [
    '$scope',
    '$state',
    'store.settings.services.SettingsService',
    'store.storeExtension_ordersexport.services.OrderExportService',
    function ($scope, $state, SettingsService, OrderExportService) {

        var ModuleName = 'storesettings_extentions';

        var defaultOption = {

        };
        $scope.absoluteUrl =  app.config.getAbsoluteUrl('@website');


        SettingsService.getOptions ({modulename: ModuleName})
            .success(
                function (data) {
                    if (!angular.isArray(data))
                    {
                        Object.keys (data).map(function (current) {
                            defaultOption[current] = data[current];
                        });
                    }
                    $scope.options = defaultOption;
                    $scope.options.enable_frontpad = !!($scope.options.enable_frontpad);

                }
            );


        $scope.save = function () {
            SettingsService
                .saveOptions (
                    {
                        modulename: ModuleName,
                        options: $scope.options
                    }
                )
                .success(
                    function (data) {
                        $scope.systemMessenger.success('STORE.SAVED');
                        $scope.options = data;

                    })
                .error (function(error) {
                    $scope.systemMessenger.error('STORE.ERROR.SAVE_CHANGES');
                });
        };
        $scope.doexport = function () {
      
            $scope.exportInProgress = true;

            OrderExportService
                .export ({
                    dates: {from: $scope.export.date_start, to: $scope.export.date_end,}
                })
                .success (function (data) {
                    $scope.exportInProgress = false;

                    if (data.exported)
                    {
                        window.location.href = data.exported;
                    }
                });
        };
    }
]);
