<?php

/***********************************************************************************************************************
 * @author: <for.samohin@gmail.com>
 **********************************************************************************************************************/
namespace MotoStore\Payment\Saman;

use MotoStore\Content\Helper\Link;
use MotoStore\Order\Entity\Order;
use MotoStore\Order\Entity\Transaction;
use MotoStore\Payment\Gateway\PaymentModule;
use Zend\Http\PhpEnvironment\Request;

class Saman extends PaymentModule
{
    public function getName()
    {
        return 'Saman';
    }

    public function getImage()
    {
        return 'saman.png';
    }

    public function getDescription()
    {
        return '';
    }

    public function getHelpText()
    {
        return '';
    }

    public function setVariables()
    {
        $this
            ->addVariable (
                self::OPTION_DISPLAY_NAME,
                array(
                    'name' => 'Display Name',
                    'type' => self::VARIABLE_TYPE_TEXT,
                    'help' => '',
                    'default' => 'Saman',
                    'required' => true,
                )
            )->addVariable (
                'MerchantID',
                array(
                    'name' => 'MerchantID',
                    'type' => self::VARIABLE_TYPE_TEXT,
                    'help' => '',
                    'default' => '',
                    'required' => true,
                )
            )->addVariable (
                'port_password',
                array(
                    'name' => 'port_password',
                    'type' => self::VARIABLE_TYPE_TEXT,
                    'help' => '',
                    'default' => '',
                    'required' => true,
                )
            )->addVariable (
                self::OPTION_ENABLED,
                array(
                    'name' => 'Enabled',
                    'type' => self::VARIABLE_TYPE_SELECT,
                    'help' => '',
                    'default' => 0,
                    'required' => true,
                    'options' => array (
                        0 => 'No',
                        1 => 'Yes'
                    ),
                )
            );
            
    }
    /**
     * @param Order $order
     * @return mixed|void
     */
    public function checkout(Order $order)
    {
        $data = array(
            "MID"  => $this->getOption ('MerchantID'),
            "ResNum"     => $order->getOrderId(),
            "Amount"       => rtrim(rtrim($order->getTotalPrice (), ''), '.'),
            "RedirectURL" => Link::storeLink ('checkout', 'success', array ('provider' => $this->getName ()), false),
            "payer_name" =>  $order->getFirstName() . ' ' . $order->getLastName(),
            "payer_mobile" => $order->getContactPhone(),
            "payer_email" => $order->getEmail(),
        );

        echo $this->form('https://sep.shaparak.ir/payment.aspx', $data);

    }

    public function handle(Request $request)
    {
        $state = $_POST['State'];
        if($state && $state=="OK" && $_POST['RefNum'])
        {
            $result=$this->Verify();
            if( $result > 0 ){
                $em = $this->serviceLocator->get ('MotoStore\EntityManager');
                $order = $this->getCurrentOrder ($_POST['RefNum']);
                $order->setStatus (Order::ORDER_PAYMENT_ACCEPTED);
                \Moto\Hook::trigger("MOTOSTORE_HOOK_ORDER_PAID",$order->getOrderId());
                $this->getCart ()
                    ->setIsSuccess (true);
                $em->merge ($order);
                $em->flush ();
            }
        }

    }
    public function verify() {
        if(isset($_POST['State']) && $_POST['State'] == "OK") {
            $soapclient = new soapclient('https://acquirer.samanepay.com/payments/referencepayment.asmx?WSDL');
            $res=  $soapclient->VerifyTransaction($_POST['RefNum'], $_POST['MID']); #reference number and MID
            return $res;
        }
    }

}